searchNodes=[{"doc":"Paraxial.io functions for use by users.","ref":"Paraxial.html","title":"Paraxial","type":"module"},{"doc":"","ref":"Paraxial.html#bulk_allowed?/3","title":"Paraxial.bulk_allowed?/3","type":"function"},{"doc":"","ref":"Paraxial.html#email_trusted?/2","title":"Paraxial.email_trusted?/2","type":"function"},{"doc":"This plug evaluates if an incoming conn should be allowed or blocked. It should be placed in the endpoint.ex file of a Phoenix application, before the Recorder plug.","ref":"Paraxial.AllowedPlug.html","title":"Paraxial.AllowedPlug","type":"module"},{"doc":"","ref":"Paraxial.AllowedPlug.html#call/2","title":"Paraxial.AllowedPlug.call/2","type":"function"},{"doc":"","ref":"Paraxial.AllowedPlug.html#init/1","title":"Paraxial.AllowedPlug.init/1","type":"function"},{"doc":"This plug is used to add metadata to the conn assigns if an IP matches a cloud provider.","ref":"Paraxial.AssignCloudIP.html","title":"Paraxial.AssignCloudIP","type":"module"},{"doc":"","ref":"Paraxial.AssignCloudIP.html#call/2","title":"Paraxial.AssignCloudIP.call/2","type":"function"},{"doc":"","ref":"Paraxial.AssignCloudIP.html#init/1","title":"Paraxial.AssignCloudIP.init/1","type":"function"},{"doc":"Plug used to block cloud provider IPs.","ref":"Paraxial.BlockCloudIP.html","title":"Paraxial.BlockCloudIP","type":"module"},{"doc":"","ref":"Paraxial.BlockCloudIP.html#call/2","title":"Paraxial.BlockCloudIP.call/2","type":"function"},{"doc":"","ref":"Paraxial.BlockCloudIP.html#init/1","title":"Paraxial.BlockCloudIP.init/1","type":"function"},{"doc":"Used to record metadata about requests for processing by Paraxial.io backend.","ref":"Paraxial.RecordPlug.html","title":"Paraxial.RecordPlug","type":"module"},{"doc":"","ref":"Paraxial.RecordPlug.html#call/2","title":"Paraxial.RecordPlug.call/2","type":"function"},{"doc":"","ref":"Paraxial.RecordPlug.html#init/1","title":"Paraxial.RecordPlug.init/1","type":"function"},{"doc":"","ref":"readme.html","title":"Paraxial.io Elixir Agent","type":"extras"},{"doc":"The Paraxial agent provides developers with several Plugs for use in the defense of their application from malicious bots. These Plugs enable the following key features: Classification and blocking of IP addresses from cloud providers, a strong signal the traffic is from a bot and not a real user. Blocking clients that violate some user defined rule, for example, If an IP sends &gt; 3 login requests in a 1 second period, create an alert and ban the IP . Custom block and allow lists, as defined in your site's Paraxial.io account.","ref":"readme.html#introduction","title":"Paraxial.io Elixir Agent - Introduction","type":"extras"},{"doc":"(Optional) Install remote_ip in your application If your application is showing a different conn.remote_ip than expected, it is probably behind a proxy. Install the remote_ip library to fix this. Install :paraxial in your application's mix.exs file: def deps do [ { :paraxial , &quot;~&gt; 0.1.0&quot; } ] end Use plug Plug.RequestId in your application's endpoint.ex file: The majority of Phoenix applications do this by default. Check your endpoint.ex file for the line: plug Plug.RequestId This plug sets x-request-id , which is required for the Paraxial agent to work correctly. Application Configuration Example: In your Paraxial.io account, we recommend creating two different sites for your application. One site for development/testing, and one site for production. For your local environment, edit your application's config/dev.exs : config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_cloud_ips : true , bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) Configuration keys and values: paraxial_api_key - Found in your site's settings page. Required for secure communication between the agent and Paraxial.io backend service. paraxial_url - This is most likely https://app.paraxial.io for your configuration. fetch_cloud_ips - By default, Paraxial.io will sent HTTP requests to retrieve the public IP ranges of several cloud providers. If you wish to disable this, set fetch_cloud_ips to false . When disabled, matching incoming requests against cloud IP addresses will not work.","ref":"readme.html#requirements-and-installation","title":"Paraxial.io Elixir Agent - Requirements and Installation","type":"extras"},{"doc":"It is highly recommend you stop here and check that your application is configured correctly for your development environment before preceding. Set your application's local logging level to debug. This will allow you to see debug messages from the Paraxial agent. Example config/dev.exs : config :logger , level : :debug Check the Paraxial lines in config/dev.exs are similar to: config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_cloud_ips : true , bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) Start your application locally, read the debug lines from Paraxial. Bad start: @ house % mix phx . server [ warning ] Paraxial API key not found . This warning means your application is not configured correctly. Check your config files. Bad start: [ error ] Task # PID &lt; 0 . 764 . 0 &gt; started from Paraxial.Crow terminating ** (Protocol.UndefinedError) protocol Enumerable not implemented for nil of type Atom. Thi This warning means you have an api_key and url defined, but at least one of them is incorrect. Check both. Good start: @ house % mix phx . server [ debug ] [ Paraxial ] :fetch_cloud_ips set to true , fetching ... [ debug ] [ Paraxial ] Prefixes downloaded for aws : 7981 [ debug ] [ Paraxial ] Prefixes downloaded for azure : 59042 [ debug ] [ Paraxial ] Prefixes downloaded for digital_ocean : 1640 [ debug ] [ Paraxial ] Prefixes downloaded for gcp : 531 [ debug ] [ Paraxial ] Prefixes downloaded for oracle : 490 [ debug ] [ Paraxial ] Prefixes length with duplicates : 69684 [ debug ] [ Paraxial ] Iptrie count - 41834 [ debug ] [ Paraxial ] Iptrie size in MB : 1.299092 [ debug ] [ Paraxial ] Agent start success [ info ] Running HouseWeb.Endpoint with cowboy 2.9 . 0 at 127.0 . 0.1 : 4002 ( http ) [ info ] Access HouseWeb.Endpoint at http :// localhost : 4002 [ watch ] build finished , watching for changes ... Now that the Paraxial agent is running in your application, it is time to configure the Paraxial Plugs.","ref":"readme.html#check-configuration-settings","title":"Paraxial.io Elixir Agent - Check Configuration Settings","type":"extras"},{"doc":"Paraxial.bulk_allowed?(email, bulk_action, count) Input: An application user's email address, the name of a bulk action, and the count for the action. Return value: True if the user is allowed to perform the action, false otherwise. Example config: config :paraxial , # ... bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) &gt; Paraxial . bulk_allowed? ( &quot;mike@blackcatprojects.xyz&quot; , :email , 3 ) &gt; true &gt; Paraxial . bulk_allowed? ( &quot;mike@blackcatprojects.xyz&quot; , :email , 100 ) &gt; true &gt; Paraxial . bulk_allowed? ( &quot;mike@test.xyz&quot; , :email , 4 ) &gt; false","ref":"readme.html#paraxial-api-functions","title":"Paraxial.io Elixir Agent - Paraxial API Functions","type":"extras"},{"doc":"The Paraxial.io Agent provides several Plugs to be used in your application code: Paraxial.AllowedPlug - Required, this Plug determines if an incoming requests matches your allow/block lists. If a request is halted by this Plug, internally Paraxial will still record it. Paraxial.RecordPlug - Required, records incoming HTTP requests into a local buffer, then sends them to the Paraxial.io backend. Paraxial.AssignCloudIP - Optional, if the remote_ip of an incoming request matching a cloud provider IP address, this plug will add metadata to the conn via an assigns. For example, if a conn's remote_ip matches aws, this plug will do assigns(conn, :paraxial_cloud_ip, :aws) . Paraxial.BlockCloudIP - Optional, similar to AssignCloudIP. When a conn matches a cloud provider IP, the assign is updated and the conn is halted, with a 404 response sent to the client.","ref":"readme.html#paraxial-plug-configuration","title":"Paraxial.io Elixir Agent - Paraxial Plug Configuration","type":"extras"},{"doc":"To install Paraxial's plugs, open your application's endpoint.ex file and add the following before and after your Router: plug Paraxial.AllowedPlug plug Paraxial.RecordPlug plug ExampleApp.Router plug Paraxial.RecordPlug When a request comes in, it first goes through the AllowedPlug. If it matches an IP on the ban list, it is blocked and the conn is halted. Requests that are halted in the AllowedPlug are still recorded, even though they never reach RecordPlug. If a request passes AllowedPlug, un-halted, it has not been recorded yet, so it goes into the RecordPlug. The reason for putting a RecordPlug before the Router is to record requests that fail to match a path in the Router. In your application you have the ability to define certain assigns, such as :paraxial_login_user_name, to map IP addresses to login attempts. After the Router, the request conn passes through RecordPlug again, with updated information (such as new assigns). If a request passes through both RecordPlugs, only the conn from the second one is recorded. FAQ Q: Phoenix applications send a response in the Router, why do you have a plug after the router? A: It is still possible to read values off a conn that has been sent back to the user. RecordPlug is read-only, it never sends a response based on the conn, so it is okay to have one after the Router.","ref":"readme.html#plug-installation","title":"Paraxial.io Elixir Agent - Plug Installation","type":"extras"},{"doc":"This is a table of every assigns value Paraxial may set on an incoming conn. To avoid conflict with assigns in your application code, each assigns is prefixed with paraxial . Key Set By Type :paraxial_login_success User Application Boolean :paraxial_login_user_name User Application String :paraxial_current_user User Application String :paraxial_cloud_ip Paraxial Agent String (aws, azure, etc.)","ref":"readme.html#paraxial-conn-assigns-index","title":"Paraxial.io Elixir Agent - Paraxial Conn Assigns Index","type":"extras"},{"doc":"To monitor login attempts, use: assign ( conn , :paraxial_login_success , true / false ) in your Phoenix application's authentication system. If you want to keep track of user names, use: assign ( conn , :paraxial_login_user_name , &quot;userNameHere&quot; )","ref":"readme.html#how-to-use-assigns-in-your-application","title":"Paraxial.io Elixir Agent - How to Use Assigns in your Application","type":"extras"},{"doc":"def deps do [ { :paraxial , &quot;~&gt; 0.0.2&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/paraxial . Mix deps versions, https://hexdocs.pm/elixir/Version.html","ref":"readme.html#installation","title":"Paraxial.io Elixir Agent - Installation","type":"extras"},{"doc":"","ref":"agent.html","title":"Agent Internals","type":"extras"},{"doc":"The main tasks of the Paraxial.io agent are: Record incoming HTTP requests and send them to the Paraxial.io backend for processing Enforce bans against IP addresses Enforce rules with a time period of &lt; 30 seconds, using local ETS tables for state","ref":"agent.html#introduction","title":"Agent Internals - Introduction","type":"extras"},{"doc":"Sent to backend: Bundles of HTTP requests, Paraxial.HTTPBuffer.send_http(state), Retrieved from backend for local use: Local rules in Paraxial.Crow Bans from backend in Paraxial.Crow Important values: How often are HTTP request bundles sent to backend? (3 seconds) Max length of local rules (30 seconds) Local bans cleared (60 seconds) Paraxial Agent: Crow: Every 3 seconds, update_local_rules() and update_backend_bans() Every 60 seconds, clear local bans HTTPBuffer: Every 3 seconds, send http bundle and clear local state. Paraxial.io backend: @local_rule_max_seconds 30 only rules with a time period &lt; @local_rule_max_seconds are sent to agent","ref":"agent.html#information-sent-received-by-agent","title":"Agent Internals - Information Sent/Received by Agent","type":"extras"},{"doc":"AllowedPlug -&gt; Paraxial.Crow.eval_http(conn) RecordPlug -&gt; if conn.assigns[:allowed] == false, halt the conn Paraxial.HTTPBuffer.add_http_event(conn/halted_conn)","ref":"agent.html#plug-module-function-map","title":"Agent Internals - Plug -&gt; Module -&gt; Function Map","type":"extras"},{"doc":"Crow: :backend_bans :local_bans :rule_names LocalRule: :local_rule_n ets_atom is used for table name ets atom is :&quot;local_rule \#{rule.id}&quot;","ref":"agent.html#ets-tables","title":"Agent Internals - ETS Tables","type":"extras"},{"doc":"By default, several Cloud hosting IP ranges are defined in the Paraxial agent: AWS Azure GCP Digital Ocean Oracle For each cloud provider, the following are defined: Cloud provider name IP prefixes URL Response to Iptrie function At some point in the future is may be possible for customers to define a custom data source. The configuration of data center IP fetching is done in the customer app config file: config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_data_center_ips : true The default value of fetch_data_center_ips is true.","ref":"cloud_ips.html","title":"Cloud IP Matching","type":"extras"},{"doc":"On agent start, get all the IP prefixes, put into Iptrie with cloud provider as value, then :persistent term.put({ _MODULE , :dc_ips}, ip_trie).","ref":"cloud_ips.html#paraxial-agent-start-and-persistent-term","title":"Cloud IP Matching - Paraxial Agent Start and Persistent Term","type":"extras"}]